diff --git a/chrono/agendas/migrations/0032_auto_20191127_0919.py b/chrono/agendas/migrations/0032_auto_20191127_0919.py
index ab55503..0e0e112 100644
--- a/chrono/agendas/migrations/0032_auto_20191127_0919.py
+++ b/chrono/agendas/migrations/0032_auto_20191127_0919.py
@@ -15,10 +15,9 @@ class Migration(migrations.Migration):
         migrations.AlterField(
             model_name='event',
             name='slug',
-            field=models.SlugField(default=None, null=True, blank=True, max_length=160, verbose_name='Identifier')
-        ),
-        migrations.AlterUniqueTogether(
-            name='event',
-            unique_together=set([('agenda', 'slug')]),
+            field=models.SlugField(
+                default=None, null=True, blank=True, max_length=160, verbose_name='Identifier'
+            ),
         ),
+        migrations.AlterUniqueTogether(name='event', unique_together=set([('agenda', 'slug')]),),
     ]
diff --git a/chrono/agendas/models.py b/chrono/agendas/models.py
index c5c8ae1..ab90a80 100644
--- a/chrono/agendas/models.py
+++ b/chrono/agendas/models.py
@@ -17,9 +17,9 @@
 
 import datetime
 import math
+
 import requests
 import vobject
-
 from django.conf import settings
 from django.contrib.auth.models import Group
 from django.core.exceptions import ValidationError
@@ -30,14 +30,12 @@ from django.utils.dates import WEEKDAYS
 from django.utils.encoding import force_text, python_2_unicode_compatible
 from django.utils.formats import date_format
 from django.utils.text import slugify
-from django.utils.timezone import localtime, now, make_aware, make_naive, is_aware
+from django.utils.timezone import is_aware, localtime, make_aware, make_naive, now
 from django.utils.translation import ugettext_lazy as _
-
 from jsonfield import JSONField
 
 from ..interval import Intervals
 
-
 AGENDA_KINDS = (
     ('events', _('Events')),
     ('meetings', _('Meetings')),
@@ -71,16 +69,28 @@ class Agenda(models.Model):
     label = models.CharField(_('Label'), max_length=150)
     slug = models.SlugField(_('Identifier'), max_length=160, unique=True)
     kind = models.CharField(_('Kind'), max_length=20, choices=AGENDA_KINDS, default='events')
-    minimal_booking_delay = models.PositiveIntegerField(
-            _('Minimal booking delay (in days)'), default=1)
+    minimal_booking_delay = models.PositiveIntegerField(_('Minimal booking delay (in days)'), default=1)
     maximal_booking_delay = models.PositiveIntegerField(
-            _('Maximal booking delay (in days)'), default=56) # eight weeks
-    edit_role = models.ForeignKey(Group, blank=True, null=True, default=None,
-            related_name='+', verbose_name=_('Edit Role'),
-            on_delete=models.SET_NULL)
-    view_role = models.ForeignKey(Group, blank=True, null=True, default=None,
-            related_name='+', verbose_name=_('View Role'),
-            on_delete=models.SET_NULL)
+        _('Maximal booking delay (in days)'), default=56
+    )  # eight weeks
+    edit_role = models.ForeignKey(
+        Group,
+        blank=True,
+        null=True,
+        default=None,
+        related_name='+',
+        verbose_name=_('Edit Role'),
+        on_delete=models.SET_NULL,
+    )
+    view_role = models.ForeignKey(
+        Group,
+        blank=True,
+        null=True,
+        default=None,
+        related_name='+',
+        verbose_name=_('View Role'),
+        on_delete=models.SET_NULL,
+    )
 
     class Meta:
         ordering = ['label']
@@ -124,7 +134,7 @@ class Agenda(models.Model):
             'permissions': {
                 'view': self.view_role.name if self.view_role else None,
                 'edit': self.edit_role.name if self.edit_role else None,
-            }
+            },
         }
         if self.kind == 'events':
             agenda['events'] = [x.export_json() for x in self.event_set.all()]
@@ -170,6 +180,7 @@ class Agenda(models.Model):
                 Desk.import_json(desk).save()
         return created
 
+
 WEEKDAYS_LIST = sorted(WEEKDAYS.items(), key=lambda x: x[0])
 
 
@@ -198,9 +209,10 @@ class TimePeriod(models.Model):
 
     def __str__(self):
         return u'%s / %s → %s' % (
-                force_text(WEEKDAYS[self.weekday]),
-                date_format(self.start_time, 'TIME_FORMAT'),
-                date_format(self.end_time, 'TIME_FORMAT'))
+            force_text(WEEKDAYS[self.weekday]),
+            date_format(self.start_time, 'TIME_FORMAT'),
+            date_format(self.end_time, 'TIME_FORMAT'),
+        )
 
     @property
     def weekday_str(self):
@@ -212,9 +224,9 @@ class TimePeriod(models.Model):
 
     def export_json(self):
         return {
-           'weekday': self.weekday,
-           'start_time': self.start_time.strftime('%H:%M'),
-           'end_time': self.end_time.strftime('%H:%M'),
+            'weekday': self.weekday,
+            'start_time': self.start_time.strftime('%H:%M'),
+            'end_time': self.end_time.strftime('%H:%M'),
         }
 
     def get_time_slots(self, min_datetime, max_datetime, meeting_type):
@@ -223,19 +235,21 @@ class TimePeriod(models.Model):
         min_datetime = make_naive(min_datetime)
         max_datetime = make_naive(max_datetime)
 
-        real_min_datetime = min_datetime + datetime.timedelta(
-                days=self.weekday - min_datetime.weekday())
+        real_min_datetime = min_datetime + datetime.timedelta(days=self.weekday - min_datetime.weekday())
         if real_min_datetime < min_datetime:
             real_min_datetime += datetime.timedelta(days=7)
 
-        event_datetime = real_min_datetime.replace(hour=self.start_time.hour,
-                minute=self.start_time.minute, second=0, microsecond=0)
+        event_datetime = real_min_datetime.replace(
+            hour=self.start_time.hour, minute=self.start_time.minute, second=0, microsecond=0
+        )
         while event_datetime < max_datetime:
             end_time = event_datetime + meeting_duration
             next_time = event_datetime + duration
             if end_time.time() > self.end_time or event_datetime.date() != next_time.date():
                 # back to morning
-                event_datetime = event_datetime.replace(hour=self.start_time.hour, minute=self.start_time.minute)
+                event_datetime = event_datetime.replace(
+                    hour=self.start_time.hour, minute=self.start_time.minute
+                )
                 # but next week
                 event_datetime += datetime.timedelta(days=7)
                 next_time = event_datetime + duration
@@ -243,7 +257,9 @@ class TimePeriod(models.Model):
             if event_datetime > max_datetime:
                 break
 
-            yield TimeSlot(start_datetime=make_aware(event_datetime), meeting_type=meeting_type, desk=self.desk)
+            yield TimeSlot(
+                start_datetime=make_aware(event_datetime), meeting_type=meeting_type, desk=self.desk
+            )
             event_datetime = next_time
 
 
@@ -265,7 +281,8 @@ class MeetingType(models.Model):
     @classmethod
     def import_json(cls, data):
         meeting_type, created = cls.objects.get_or_create(
-            slug=data['slug'], agenda=data['agenda'], defaults=data)
+            slug=data['slug'], agenda=data['agenda'], defaults=data
+        )
         if not created:
             for k, v in data.items():
                 setattr(meeting_type, k, v)
@@ -273,9 +290,9 @@ class MeetingType(models.Model):
 
     def export_json(self):
         return {
-           'label': self.label,
-           'slug': self.slug,
-           'duration': self.duration,
+            'label': self.label,
+            'slug': self.slug,
+            'duration': self.duration,
         }
 
 
@@ -284,13 +301,18 @@ class Event(models.Model):
     agenda = models.ForeignKey(Agenda, on_delete=models.CASCADE)
     start_datetime = models.DateTimeField(_('Date/time'))
     places = models.PositiveIntegerField(_('Places'))
-    waiting_list_places = models.PositiveIntegerField(
-            _('Places in waiting list'), default=0)
-    label = models.CharField(_('Label'), max_length=150, null=True, blank=True,
-            help_text=_('Optional label to identify this date.'))
+    waiting_list_places = models.PositiveIntegerField(_('Places in waiting list'), default=0)
+    label = models.CharField(
+        _('Label'),
+        max_length=150,
+        null=True,
+        blank=True,
+        help_text=_('Optional label to identify this date.'),
+    )
     slug = models.SlugField(_('Identifier'), max_length=160, null=True, blank=True, default=None)
-    description = models.TextField(_('Description'), null=True, blank=True,
-            help_text=_('Optional event description.'))
+    description = models.TextField(
+        _('Description'), null=True, blank=True, help_text=_('Optional event description.')
+    )
     full = models.BooleanField(default=False)
     meeting_type = models.ForeignKey(MeetingType, null=True, on_delete=models.CASCADE)
     desk = models.ForeignKey('Desk', null=True, on_delete=models.CASCADE)
@@ -310,14 +332,24 @@ class Event(models.Model):
 
     def check_full(self):
         self.full = bool(
-            (self.booked_places >= self.places and self.waiting_list_places == 0) or
-            (self.waiting_list_places and self.waiting_list >= self.waiting_list_places))
+            (self.booked_places >= self.places and self.waiting_list_places == 0)
+            or (self.waiting_list_places and self.waiting_list >= self.waiting_list_places)
+        )
 
     def in_bookable_period(self):
-        if localtime(now()).date() > localtime(self.start_datetime - datetime.timedelta(days=self.agenda.minimal_booking_delay)).date():
+        if (
+            localtime(now()).date()
+            > localtime(
+                self.start_datetime - datetime.timedelta(days=self.agenda.minimal_booking_delay)
+            ).date()
+        ):
             return False
         if self.agenda.maximal_booking_delay and (
-                localtime(now()).date() <= localtime(self.start_datetime - datetime.timedelta(days=self.agenda.maximal_booking_delay)).date()):
+            localtime(now()).date()
+            <= localtime(
+                self.start_datetime - datetime.timedelta(days=self.agenda.maximal_booking_delay)
+            ).date()
+        ):
             return False
         if self.start_datetime < now():
             # past the event date, we may want in the future to allow for some
@@ -327,13 +359,11 @@ class Event(models.Model):
 
     @property
     def booked_places(self):
-        return self.booking_set.filter(cancellation_datetime__isnull=True,
-                in_waiting_list=False).count()
+        return self.booking_set.filter(cancellation_datetime__isnull=True, in_waiting_list=False).count()
 
     @property
     def waiting_list(self):
-        return self.booking_set.filter(cancellation_datetime__isnull=True,
-                in_waiting_list=True).count()
+        return self.booking_set.filter(cancellation_datetime__isnull=True, in_waiting_list=True).count()
 
     @property
     def end_datetime(self):
@@ -344,8 +374,9 @@ class Event(models.Model):
 
     @classmethod
     def import_json(cls, data):
-        data['start_datetime'] = make_aware(datetime.datetime.strptime(
-            data['start_datetime'], '%Y-%m-%d %H:%M:%S'))
+        data['start_datetime'] = make_aware(
+            datetime.datetime.strptime(data['start_datetime'], '%Y-%m-%d %H:%M:%S')
+        )
         if data.get('slug'):
             event, created = cls.objects.get_or_create(slug=data['slug'], defaults=data)
             if not created:
@@ -372,11 +403,14 @@ class Booking(models.Model):
     in_waiting_list = models.BooleanField(default=False)
     creation_datetime = models.DateTimeField(auto_now_add=True)
     # primary booking is used to group multiple bookings together
-    primary_booking = models.ForeignKey('self', null=True,
-            on_delete=models.CASCADE, related_name='secondary_booking_set')
+    primary_booking = models.ForeignKey(
+        'self', null=True, on_delete=models.CASCADE, related_name='secondary_booking_set'
+    )
 
     label = models.CharField(max_length=250, blank=True)
-    user_display_label = models.CharField(verbose_name=_('Label displayed to user'), max_length=250, blank=True)
+    user_display_label = models.CharField(
+        verbose_name=_('Label displayed to user'), max_length=250, blank=True
+    )
     user_name = models.CharField(max_length=250, blank=True)
     backoffice_url = models.URLField(blank=True)
 
@@ -405,14 +439,20 @@ class Booking(models.Model):
         ics = vobject.iCalendar()
         ics.add('prodid').value = '-//Entr\'ouvert//NON SGML Publik'
         vevent = vobject.newFromBehavior('vevent')
-        vevent.add('uid').value = '%s-%s-%s' % (self.event.start_datetime.isoformat(), self.event.agenda.pk, self.pk)
+        vevent.add('uid').value = '%s-%s-%s' % (
+            self.event.start_datetime.isoformat(),
+            self.event.agenda.pk,
+            self.pk,
+        )
 
         vevent.add('summary').value = self.user_display_label or self.label
         vevent.add('dtstart').value = self.event.start_datetime
         if self.user_name:
             vevent.add('attendee').value = self.user_name
         if self.event.meeting_type:
-            vevent.add('dtend').value = self.event.start_datetime + datetime.timedelta(minutes=self.event.meeting_type.duration)
+            vevent.add('dtend').value = self.event.start_datetime + datetime.timedelta(
+                minutes=self.event.meeting_type.duration
+            )
 
         for field in ('description', 'location', 'comment', 'url'):
             field_value = request and request.GET.get(field) or self.extra_data.get(field)
@@ -422,15 +462,14 @@ class Booking(models.Model):
         return ics.serialize()
 
 
-
 @python_2_unicode_compatible
 class Desk(models.Model):
     agenda = models.ForeignKey(Agenda, on_delete=models.CASCADE)
     label = models.CharField(_('Label'), max_length=150)
     slug = models.SlugField(_('Identifier'), max_length=160)
     timeperiod_exceptions_remote_url = models.URLField(
-            _('URL to fetch time period exceptions from'),
-            blank=True, max_length=500)
+        _('URL to fetch time period exceptions from'), blank=True, max_length=500
+    )
 
     def __str__(self):
         return self.label
@@ -448,8 +487,7 @@ class Desk(models.Model):
     def import_json(cls, data):
         timeperiods = data.pop('timeperiods')
         exceptions = data.pop('exceptions')
-        instance, created = cls.objects.get_or_create(
-            slug=data['slug'], agenda=data['agenda'], defaults=data)
+        instance, created = cls.objects.get_or_create(slug=data['slug'], agenda=data['agenda'], defaults=data)
         if not created:
             for k, v in data.items():
                 setattr(instance, k, v)
@@ -462,21 +500,24 @@ class Desk(models.Model):
         return instance
 
     def export_json(self):
-        return {'label': self.label,
-                'slug': self.slug,
-                'timeperiods': [time_period.export_json() for time_period in self.timeperiod_set.all()],
-                'exceptions': [exception.export_json() for exception in self.timeperiodexception_set.all()]
-                }
+        return {
+            'label': self.label,
+            'slug': self.slug,
+            'timeperiods': [time_period.export_json() for time_period in self.timeperiod_set.all()],
+            'exceptions': [exception.export_json() for exception in self.timeperiodexception_set.all()],
+        }
 
     def get_exceptions_within_two_weeks(self):
         in_two_weeks = make_aware(datetime.datetime.today() + datetime.timedelta(days=14))
         exceptions = self.timeperiodexception_set.filter(end_datetime__gte=now()).filter(
-                Q(end_datetime__lte=in_two_weeks) | Q(start_datetime__lt=now()))
+            Q(end_datetime__lte=in_two_weeks) | Q(start_datetime__lt=now())
+        )
         if exceptions.exists():
             return exceptions
         # if none found within the 2 coming weeks, return the next one
-        next_exception = self.timeperiodexception_set.filter(
-            start_datetime__gte=now()).order_by('start_datetime').first()
+        next_exception = (
+            self.timeperiodexception_set.filter(start_datetime__gte=now()).order_by('start_datetime').first()
+        )
         if next_exception:
             return [next_exception]
         return []
@@ -491,12 +532,14 @@ class Desk(models.Model):
             response.raise_for_status()
         except requests.HTTPError as e:
             raise ICSError(
-                _('Failed to retrieve remote calendar (%(url)s, HTTP error %(status_code)s).') %
-                {'url': url, 'status_code': e.response.status_code})
+                _('Failed to retrieve remote calendar (%(url)s, HTTP error %(status_code)s).')
+                % {'url': url, 'status_code': e.response.status_code}
+            )
         except requests.RequestException as e:
             raise ICSError(
-                _('Failed to retrieve remote calendar (%(url)s, %(exception)s).') %
-                {'url': url, 'exception': e})
+                _('Failed to retrieve remote calendar (%(url)s, %(exception)s).')
+                % {'url': url, 'exception': e}
+            )
 
         return self.create_timeperiod_exceptions_from_ics(response.text, keep_synced_by_uid=True)
 
@@ -582,7 +625,9 @@ class Desk(models.Model):
                         if end_dt < update_datetime:
                             TimePeriodException.objects.filter(**kwargs).update(**event)
                         else:
-                            obj, created = TimePeriodException.objects.update_or_create(defaults=event, **kwargs)
+                            obj, created = TimePeriodException.objects.update_or_create(
+                                defaults=event, **kwargs
+                            )
                             if created:
                                 total_created += 1
                     # delete unseen occurrences
@@ -591,8 +636,9 @@ class Desk(models.Model):
 
             if keep_synced_by_uid:
                 # delete all outdated exceptions from remote calendar
-                TimePeriodException.objects.filter(update_datetime__lt=update_datetime,
-                                    desk=self).exclude(external_id='').delete()
+                TimePeriodException.objects.filter(update_datetime__lt=update_datetime, desk=self).exclude(
+                    external_id=''
+                ).delete()
 
         return total_created
 
@@ -606,8 +652,8 @@ class Desk(models.Model):
         aware_date = make_aware(datetime.datetime(date.year, date.month, date.day))
         aware_next_date = aware_date + datetime.timedelta(days=1)
         for exception in self.timeperiodexception_set.filter(
-                start_datetime__lt=aware_next_date,
-                end_datetime__gt=aware_date):
+            start_datetime__lt=aware_next_date, end_datetime__gt=aware_date
+        ):
             openslots.remove(exception.start_datetime, exception.end_datetime)
 
         return openslots.search(aware_date, aware_next_date)
@@ -634,18 +680,21 @@ class TimePeriodException(models.Model):
                 exc_repr = u'%s' % date_format(localtime(self.start_datetime), 'SHORT_DATE_FORMAT')
             else:
                 exc_repr = u'%s → %s' % (
-                        date_format(localtime(self.start_datetime), 'SHORT_DATE_FORMAT'),
-                        date_format(localtime(self.end_datetime), 'SHORT_DATE_FORMAT'))
+                    date_format(localtime(self.start_datetime), 'SHORT_DATE_FORMAT'),
+                    date_format(localtime(self.end_datetime), 'SHORT_DATE_FORMAT'),
+                )
         else:
             if localtime(self.start_datetime).date() == localtime(self.end_datetime).date():
                 # same day
                 exc_repr = u'%s → %s' % (
-                        date_format(localtime(self.start_datetime), 'SHORT_DATETIME_FORMAT'),
-                        date_format(localtime(self.end_datetime), 'TIME_FORMAT'))
+                    date_format(localtime(self.start_datetime), 'SHORT_DATETIME_FORMAT'),
+                    date_format(localtime(self.end_datetime), 'TIME_FORMAT'),
+                )
             else:
                 exc_repr = u'%s → %s' % (
-                        date_format(localtime(self.start_datetime), 'SHORT_DATETIME_FORMAT'),
-                        date_format(localtime(self.end_datetime), 'SHORT_DATETIME_FORMAT'))
+                    date_format(localtime(self.start_datetime), 'SHORT_DATETIME_FORMAT'),
+                    date_format(localtime(self.end_datetime), 'SHORT_DATETIME_FORMAT'),
+                )
 
         if self.label:
             exc_repr = u'%s (%s)' % (self.label, exc_repr)
@@ -662,9 +711,8 @@ class TimePeriodException(models.Model):
             # incomplete time period, can't tell
             return False
         for event in Event.objects.filter(
-                desk=self.desk,
-                booking__isnull=False,
-                booking__cancellation_datetime__isnull=True):
+            desk=self.desk, booking__isnull=False, booking__cancellation_datetime__isnull=True
+        ):
             if self.start_datetime <= event.start_datetime < self.end_datetime:
                 return True
         return False
diff --git a/chrono/api/urls.py b/chrono/api/urls.py
index 79ee179..d9c5121 100644
--- a/chrono/api/urls.py
+++ b/chrono/api/urls.py
@@ -21,29 +21,32 @@ from . import views
 urlpatterns = [
     url(r'agenda/$', views.agendas),
     url(r'agenda/(?P<agenda_identifier>[\w-]+)/$', views.agenda_detail),
-
     url(r'agenda/(?P<agenda_identifier>[\w-]+)/datetimes/$', views.datetimes, name='api-agenda-datetimes'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/fillslot/(?P<event_identifier>[\w:-]+)/$',
-        views.fillslot, name='api-fillslot'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/fillslots/$',
-        views.fillslots, name='api-agenda-fillslots'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/status/(?P<event_identifier>[\w-]+)/$', views.slot_status,
-        name='api-event-status'),
-
-    url(r'agenda/meetings/(?P<meeting_identifier>[\w-]+)/datetimes/$',
-        views.meeting_datetimes, name='api-agenda-meeting-datetimes-legacy'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/meetings/$',
-        views.meeting_list, name='api-agenda-meetings'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/desks/$',
-        views.agenda_desk_list, name='api-agenda-desks'),
-    url(r'agenda/(?P<agenda_identifier>[\w-]+)/meetings/(?P<meeting_identifier>[\w-]+)/datetimes/$',
-        views.meeting_datetimes, name='api-agenda-meeting-datetimes'),
-
+    url(
+        r'agenda/(?P<agenda_identifier>[\w-]+)/fillslot/(?P<event_identifier>[\w:-]+)/$',
+        views.fillslot,
+        name='api-fillslot',
+    ),
+    url(r'agenda/(?P<agenda_identifier>[\w-]+)/fillslots/$', views.fillslots, name='api-agenda-fillslots'),
+    url(
+        r'agenda/(?P<agenda_identifier>[\w-]+)/status/(?P<event_identifier>[\w-]+)/$',
+        views.slot_status,
+        name='api-event-status',
+    ),
+    url(
+        r'agenda/meetings/(?P<meeting_identifier>[\w-]+)/datetimes/$',
+        views.meeting_datetimes,
+        name='api-agenda-meeting-datetimes-legacy',
+    ),
+    url(r'agenda/(?P<agenda_identifier>[\w-]+)/meetings/$', views.meeting_list, name='api-agenda-meetings'),
+    url(r'agenda/(?P<agenda_identifier>[\w-]+)/desks/$', views.agenda_desk_list, name='api-agenda-desks'),
+    url(
+        r'agenda/(?P<agenda_identifier>[\w-]+)/meetings/(?P<meeting_identifier>[\w-]+)/datetimes/$',
+        views.meeting_datetimes,
+        name='api-agenda-meeting-datetimes',
+    ),
     url(r'booking/(?P<booking_pk>\w+)/$', views.booking),
-    url(r'booking/(?P<booking_pk>\w+)/cancel/$', views.cancel_booking,
-        name='api-cancel-booking'),
-    url(r'booking/(?P<booking_pk>\w+)/accept/$', views.accept_booking,
-        name='api-accept-booking'),
-    url(r'booking/(?P<booking_pk>\w+)/ics/$', views.booking_ics,
-        name='api-booking-ics'),
+    url(r'booking/(?P<booking_pk>\w+)/cancel/$', views.cancel_booking, name='api-cancel-booking'),
+    url(r'booking/(?P<booking_pk>\w+)/accept/$', views.accept_booking, name='api-accept-booking'),
+    url(r'booking/(?P<booking_pk>\w+)/ics/$', views.booking_ics, name='api-booking-ics'),
 ]
